using Bp.Sync.BackEnd.Infrastructure.Repositories;
using Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.FcBusinesses.UnitExchanges
{
    public class SyncFcUnitExchangeHandler : MediatR.IRequestHandler<SyncFcUnitExchangeCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IFcUnitExchangeRepository _FcUnitExchangeRepository;
        private readonly IBus _bus;
        private readonly IUnitRepository _unitRepository;

        public SyncFcUnitExchangeHandler(IConfiguration configuration,
            IUnitRepository unitRepository,
            IFcUnitExchangeRepository FcUnitExchangeRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("FcBusinessConnection");
            _dbConnection = new SqlConnection(connectionString);
            _FcUnitExchangeRepository = FcUnitExchangeRepository;
            _bus = bus;
            _unitRepository = unitRepository;
        }

        public async Task<BaseResult> Handle(SyncFcUnitExchangeCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticFcUnitExchange", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} FcUnitExchanges" };
            }

            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }
            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var FcUnitExchanges = await _dbConnection.QueryAsync<Domain.Entities.FcBusinesses.UnitExchanges.UnitExchange>("Sync_UnitExchange_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (FcUnitExchanges.Any())
                {
                    var units = await _unitRepository.GetAll();
                    var FcUnitExchangeRs = FcUnitExchanges.ToFcUnitExchanges();
                    foreach (var item in FcUnitExchangeRs)
                    {
                        item.HeadQuarterParentUnitName = units.Items.FirstOrDefault(x => x.Id == item.HeadQuarterParentUnitId)?.Name;
                        item.HeadQuarterUnitName = units.Items.FirstOrDefault(x => x.Id == item.HeadQuarterUnitId)?.Name;
                    }
                    var rs2 = await _FcUnitExchangeRepository.AddManyAsync(FcUnitExchangeRs);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_UnitExchange_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{FcUnitExchangeRs.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}